%
% d17-11 yƧɤTɤlnv
%
clear;  close  all;
clc
%
% wƾ
%
z=0:0.5:2.0;  % bVm(m)
P=[1.80  1.38  1.09  0.63  0.18]*1.e3;  % O(Pa)
%
rho_g=1.2;  % ۱K(kg/m^3)
rho_s=2650;  % G۱K(kg/m^3)
g=9.81;  % O[t(m/s^2)
%
% pdP/dz
%
SP=spaps(z, P, 1e-3);  % QζuXƾ
dSP=fnder(SP);
dPdz=fnval(dSP, z);
%
% pnv
%
epson_s=(-dPdz-rho_g*g)/(g*(rho_s-rho_g));
%
% GX
%
plot(z,100*epson_s)
title('Tɤlnv')
xlabel('bVm(m)')
ylabel('nv(%)')
%
fprintf('\n nv=%7.3f %%\n',100*mean(epson_s))
