function  ex18_14
%
% d 18-14  Van der Pol{ 
%
clear
clc
close  all
%
global  mu
%
x0=[2  0]; % _l
tspan=0: 1000;
%
mu=0.1;
%
[t,x]=ode45(@odefun, tspan, x0);
%
y=x(:,1);
dydt=x(:,2);
%
subplot(1,2,1)
plot(y,dydt)  % ۹
xlabel('y')
ylabel('dy/dt')
title('Van de Pol Eq. with \mu=0.1')
%
% 
mu=1;
%
[t,x]=ode45(@odefun, tspan, x0);
%
y=x(:,1);
dydt=x(:,2);
%
subplot(1,2,2)
plot(y,dydt)
xlabel('y')
ylabel('dy/dt')
title('Van de Pol Eq. with \mu=1')
%
% Van de Pol Eq.
%
function  xdot=odefun(t,x)
global  mu
x1=x(1);
x2=x(2);
xdot=[x2
      mu*(1-x1^2)*x2-x1];
