function  ex18_15
%
% d 18-15  TޤOB 
%
clear
clc
close  all
%
global  G  M  m  D  d  w  
%
% model parameters
%
G=6.67384e-11;  % m^3/kg.s^2
M=5.974e24;  % kg
m=7.348e22;  % kg
D=3.844e8;  % m
d=4.669e6;  % m
w=2.661e-6;  %  rad/s
R=6.378e6;  %  m
%
u0=[4.613e8  0  0  -1074]; % _l
tfinal= 2.5e6;
%
% D
%
[t, u]=ode45(@odefun, [0  tfinal], u0);
%
x=u(:,1);
y=u(:,3);
r1=sqrt((x+d).^2+y.^2);
r2=sqrt((D-d-x).^2+y.^2);
%
Dist_min=min(r1)-R;
fprintf('\n 澹Za̪Z %.3e .\n', Dist_min/1e3)
%
plot(x,y)  
xlabel('x')
ylabel('y')
title('澹Bʭy')
%
figure(2)
plot(t,r1,'r',t,r2,'-.b')
xlabel('ɶ ()')
ylabel('r1 M r2')
title('澹ZaΤ뤧Zܤ')
legend('ZayyߤZ','ZyyߤZ')
%
% 澹bŶBʭyҦ
%
function  udot=odefun(t,u)
global  G  M  m  D  d  w  
x=u(1); dx=u(2);
y=u(3); dy=u(4);
r1=sqrt((x+d)^2+y^2);
r2=sqrt((D-d-x)^2+y^2);
%
a=M*(x+(m/(M+m))*D)/r1^3+m*(x-(M/(M+m))*D)/r2^3;
b=M*y/r1^3+m*y/r2^3;
udot=[dx
      -G*a+w^2*x+2*w*dy
      dy
      -G*b+w^2*y-2*w*dx];
