function  ex18_16
%
% d 18-16  `ubw챱ʺA 
%
clear
clc
close  all
%
global  a1  a2  a3  a4  Kp  KD  q1d  q2d
%
% parameters
%
m1=1;
L1=1;
me=2;
de=30;
I1=0.12;
Lc1=0.5;
Ie=0.25;
Lce=0.6;
Kp=2000;
KD=100;
%
% setpoints
%
q1d=45;
q2d=90;
%
a1=I1+m1*Lc1^2+Ie+me*Lce^2+me*L1^2;
a2=Ie+me*Lce^2;
a3=me*L1*Lce*cos(de);
a4=me*L1*Lce*sin(de);
%
x0=[0  0  0  0]; % _l
tfinal= 1;
%
% D
%
[t, x]=ode45(@odefun, [0  tfinal], x0);
%
q1=x(:,1); dq1=x(:,2);
q2=x(:,3); dq2=x(:,4);
%
% OJ
%
tau=-Kp*[q1-q1d  q2-q2d]'-KD*[dq1 dq2]';
%
figure(1)
subplot(2,1,1)
plot(t,q1)  
ylabel('`q_1')
title('`uw챱ʺA')
%
subplot(2,1,2)
plot(t,q2)
xlabel('ɶ ()')
ylabel('`q_2')
%
figure(2)
subplot(2,1,1)
plot(t,tau(1,:))  
ylabel('O\tau_1')
title('`uOJ')
%
subplot(2,1,2)
plot(t,tau(2,:))
xlabel('ɶ ()')
ylabel('O\tau_2')
%
% `uw챱Ҧ
%
function  xdot=odefun(t,x)
global  a1  a2  a3  a4  Kp  KD  q1d  q2d
q1=x(1); dq1=x(2);
q2=x(3); dq2=x(4);
%
H11=a1+2*a3*cos(q2)+2*a4*sin(q2);
H12=a2+a3*cos(q2)+a4*sin(q2);
H21=H12;
H22=a2;
h=a3*sin(q2)-a4*cos(q2);
%
%  (control law)
%
tau=-Kp*[q1-q1d  q2-q2d]'-KD*[dq1 dq2]';
%
H=[H11  H12; H21  H22];
B=[h*dq2  h*(dq1+dq2);  -h*dq1  0];
C=B*[dq1  dq2]';
A=inv(H)*(C+tau);
%
xdot=[dq1
      A(1)
      dq2
      A(2)];
