function  ex18_10
%
% d 18-10  qϱyFʺA
%
clear
clc
close  all
%
global L  I  R  KT  Ke  C
%
L=0.002; % FqP (H)
I=5e-5;  % FʺDq (kg.m^2)
R=8;     % Fq (کi)
KT=0.03;  % Ox` (N.m/A)
Ke=0.05;  % Ϲqʶձ` (V.s/rad)
C=0.1;   
%
x0=[0  0]; % _l
tspan=[0  0.01]; % ɶ
%
[t,x]=ode15s(@odefun, tspan, x0);
%
i=x(:,1);
w=x(:,2);
%
plot(t*1e3, i, 'r', t*1e3, w, 'b')  
xlabel('ɶ(L)')
ylabel('FqyMt')
title('qϱyFʺA')
legend('Fqy','t')
%
% qϱyFʺA{
%
function  xdot=odefun(t,x)
global L  I  R  KT  Ke  C
i=x(1);
w=x(2);
v=5;
xdot=[1/L*(-R*i-Ke*w+v)
      1/I*(KT*i-C*w)];
