function  ex18_17
%
% d18-17  G-G۶ಾʤƤtΤʺA
%
clear 
clc
close  all
%
global  P  alpha  NR0  NY0  NX0  NQ0
%
% wƾ
%
P=[25.129  167.915  141.676  0.696  0.066  689.234  837.295]; % ҦѼƭ
alpha=0.5; % oBۤn
NR0=2; % lɡAoۤyMy@`M (mol/L)
NY0=1.5; % lɡAoBۤl@`M (mol/L)
NX0=2.1; % lɡAoBۤl@פ`M (mol/L)
NQ0=0.1; % ͤƥ|BϿ@ (mol/L)
%
% w M x} ]Mass matrix^
%
M=[1  0  0 
   0  1  0
   0  0  0];
%
% _lȤμɶ
%
y0=[2  0  0.1]';
tspan=[0  logspace(-5,5)];  % `N: HlogspaceI
%
% DѰѼƳ]w
%
options=odeset('Mass', M, 'MassSingular', 'yes', 'RelTol', 1e-4,...
 'AbsTol', [1e-6  1e-10  1e-6]);
%
% D
%
[t,y]=ode15s(@DAEfun, tspan, y0, options);
%
% GXø
%
subplot(3,1,1)
semilogx(t,y(:,1))
ylabel('y_1')
subplot(3,1,2)
semilogx(t,y(:,2))
ylabel('y_2')
subplot(3,1,3)
semilogx(t,y(:,3))
xlabel('time (min)')
ylabel('y_3')
%
% DAE tΤ{
%
function f=DAEfun(t, y)
global  P  alpha  NR0  NY0  NX0  NQ0
P1=P(1);P2=P(2);P3=P(3);P4=P(4);P5=P(5);P6=P(6);P7=P(7);
y1=y(1);y2=y(2);y3=y(3);
a=P5*(NX0-alpha*y1)*y3/(alpha*P5*y3+y3+P7);
b=-P1*y1*y2+P2*(NR0-y1)*a;
c=(NY0-alpha*(NR0-y1+y2))/(1+P6/y3);
f=[ b
    b-P3*(y2-P4*c)
    -NQ0+alpha*(y2+a)+y3+c+(NX0-alpha*(y1+a))/(1+P7/y3)];
