%
% d20-5 TĲCtv
%
clear
clc
% 
% ƾ
%
PH=[0.7494  0.6721  0.5776  0.5075  0.9256  0.9266  0.8766  0.7564  0.5617  0.5241];
PB=[0.2670  0.3424  0.4342  0.5043  0.1020  0.0997  0.1471  0.2607  0.4501  0.4877];
r0=[0.2182  0.2208  0.2235  0.1892  0.1176  0.1151  0.1472  0.2178  0.2122  0.2024];
% 
n=length(r0);	
A=[ones(n,1)  PH'  PB'];
R=(PH.^3.*PB./r0).^(1/4);
B=R';
%
% pѼƭ
%
y=A\B;
a=y(1); b=y(2); c=y(3);
%
% pҦѼƭ
%
KH=b/a;
KB=c/a;
k=a^(-4)*KH^(-3)/KB;
%    
% CLX
%
fprintf('ҦѼƦȬ: KH=%.4f, KB=%.4f, k=%.4f\n', KH,  KB,  k)
%
% Ҧ~tR
%
r0_model=k*KH^3*KB*PH.^3.*PB./(1+KH*PH+KB*PB).^4;
error=r0-r0_model;
%
disp(' ')    
disp(' data no.   r0 (measured)   r0 (model)       error')
for i=1:n
  fprintf('\n %2i %15.4f %15.4f %15.4f',i,r0(i),r0_model(i),error(i))
end 
